## blis 1.1

=== Makefile ===
dlvl = ./.
include $(dlvl)/Makefile.in

all: alllib alltst 

help:
	@ echo "Make sure you are using correct Makefile.in for your system."
	@ echo "At this level, assuming you have downloded all necessary    "
	@ echo "files and made an archive file of BLAS routines for your    "
	@ echo "system."
	@ echo " "
	@ echo "The Makefile compiles the routines of CBLAS (C interface of "
	@ echo "BLAS) and testers for all the precisions.                   "
	@ echo "If there is no directory for archives in CBLAS/lib, it      "
	@ echo "creates new directory with the name of the platform of your "
	@ echo "machine." 
	@ echo " "
	@ echo "To compile, you have to type as follows"
	@ echo "make <target>"
	@ echo " where <target> is one of:"
	@ echo "slib1 --- make an archive of level 1 REAL."
	@ echo "dlib1 --- make an archive of level 1 DOUBLE PRECISION."
	@ echo "clib1 --- make an archive of level 1 COMPLEX."
	@ echo "zlib1 --- make an archive of level 1 COMPLEX*16."
	@ echo "alllib1 - make an archive of level 1 all precisions."
	@ echo " "
	@ echo "slib2 --- make an archive of level 2 REAL."
	@ echo "dlib2 --- make an archive of level 2 DOUBLE PRECSION."
	@ echo "clib2 --- make an archive of level 2 COMPLEX."
	@ echo "zlib2 --- make an archive of level 2 COMPLEX*16."
	@ echo "alllib2 - make an archive of level 2 all precisions."
	@ echo " "
	@ echo "slib3 --- make an archive of level 3 REAL."
	@ echo "dlib3 --- make an archive of level 3 DOUBLE PRECISION ."
	@ echo "clib3 --- make an archive of level 3 COMPLEX."
	@ echo "zlib3 --- make an archive of level 3 COMPLEX*16."
	@ echo "alllib3 - make an archive of level 3 all precisions."
	@ echo " "
	@ echo "alllib -- make an archive for all precisions."
	@ echo " "
	@ echo "stest1 -- Compiles the tester for level 1 REAL."
	@ echo "dtest1 -- Compiles the tester for level 1 DOUBLE PRECISION. "
	@ echo "ctest1 -- Compiles the tester for level 1 COMPLEX."
	@ echo "ztest1 -- Compiles the tester for level 1 COMPLEX*16."
	@ echo "alltst1 - Compiles testers for all precisions of level 1." 
	@ echo " "
	@ echo "stest2 -- Compiles the tester for level 2 REAL."
	@ echo "dtest2 -- Compiles the tester for level 2 DOUBLE PRECISION. "
	@ echo "ctest2 -- Compiles the tester for level 2 COMPLEX."
	@ echo "ztest2 -- Compiles the tester for level 2 COMPLEX*16."
	@ echo "alltst2 - Compiles testers for all precisions of level 2." 
	@ echo " "
	@ echo "stest3 -- Compiles the tester for level 3 REAL."
	@ echo "dtest3 -- Compiles the tester for level 3 DOUBLE PRECISON. "
	@ echo "ctest3 -- Compiles the tester for level 3 COMPLEX."
	@ echo "ztest3 -- Compiles the tester for level 3 COMPLEX*16."
	@ echo "alltst3 - Compiles testers for all precisions of level 3." 
	@ echo " "
	@ echo "alltst -- Compiles testers for all CBLAS routines." 
	@ echo "runtst -- Execute testers for all CBLAS routines." 
	@ echo " "
	@ echo "all ----- Creates a library and testers for ALL." 
	@ echo " "
	@ echo "clean --- Erase all the .o and excutable files" 
	@ echo "cleanlib -- Erase all the .o  files" 
	@ echo "cleanexe -- Erase all the excutable files" 
	@ echo "rmlib --- Remove a library file." 
	@ echo " "
	@ echo "example -- Creates example1 and example2"
	@ echo "example1 -- A small example to exercise the interface "
	@ echo "example2 -- Test that cblas_xerbla() is working correctly"
	@ echo " "
	@ echo " ------- Warning ------- "
	@ echo "If you want just to make a tester, make sure you have"
	@ echo "already made an archive file out of CBLAS routines."
	@ echo " "
	@ echo "Written by Keita Teranishi"
	@ echo "3/4/98 "


# In general, the Makefile call other Makefiles in the sub-directories.


clean:
	( cd testing && make clean )
	( cd src && make clean )
	rm -f *.o cblas_ex1 cblas_ex2

cleanobj:
	( cd testing && make cleanobj )
	( cd src && make clean )

cleanexe:
	( cd testing && make cleanexe )

rmlib:
	( rm -f $(CBLIB) )
slib1:  sreal1
dlib1:  dreal1
clib1:  scplx1
zlib1:  dcplx1
slib2:  sreal2
dlib2:  dreal2
clib2:  scplx2
zlib2:  dcplx2
slib3:  sreal3
dlib3:  dreal3
clib3:  scplx3 
zlib3:  dcplx3 
alllib1: allprecision1
alllib2: allprecision2
alllib3: allprecision3
alllib:  allprecision


sreal1:
	( cd src && make slib1)
dreal1:
	( cd src && make dlib1)
scplx1:
	( cd src && make clib1)
dcplx1:
	( cd src && make zlib1)
allprecision1:
	( cd src && make all1)
sreal2:
	( cd src && make slib2)
dreal2:
	( cd src && make dlib2)
scplx2:
	( cd src && make clib2)
dcplx2:
	( cd src && make zlib2)
allprecision2:
	( cd src && make all2)
sreal3:
	( cd src && make slib3)
dreal3:
	( cd src && make dlib3)
scplx3:
	( cd src && make clib3)
dcplx3:
	( cd src && make zlib3)
allprecision3:
	( cd src && make all3)
allprecision:
	( cd src && make all)

stest1: 
	( cd testing && make stest1 )
dtest1: 
	( cd testing && make dtest1 )
ctest1: 
	( cd testing && make ctest1 )
ztest1: 
	( cd testing && make ztest1 )
alltst1:
	( cd testing && make all1 )
stest2:
	( cd testing && make stest2 )
dtest2:
	( cd testing && make dtest2 )
ctest2:
	( cd testing && make ctest2 )
ztest2:
	( cd testing && make ztest2 )
alltst2:
	( cd testing && make all2 )
stest3:
	( cd testing && make stest3 )
dtest3:
	( cd testing && make dtest3 )
ctest3:
	( cd testing && make ctest3 )
ztest3:
	( cd testing && make ztest3 )
alltst3:
	( cd testing && make all3 )
alltst:
	( cd testing && make all )
runtst:
	( cd testing && make run )
	
example: alllib
	( cd examples && make all )
example1: alllib
	( cd examples && make example1 )
example2: alllib
	( cd examples && make example1 )

   
cleanall:
	( cd src && rm -f a.out core *.o $(CBLIB) )
	( cd testing && rm -f *.out core *.o x[sdcz]cblat[123] )
	( cd examples && rm -f *.o cblas_ex1 cblas_ex2 )

=== blastest/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for BLAS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all f2c bin \
        clean cleanf2c cleanobj cleanbin cleanout \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        run check



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_OBJ_PATH  := obj

F2C_LIB        := libf2c.a

F2C_PATH       := f2c
DRIVER_PATH    := src
BLIS_H_PATH    := $(BUILD_PATH)/$(BASE_INC_PATH)

INPUT_DIR      := input

# Gather all local object files.
F2C_OBJS       := $(sort $(patsubst $(F2C_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(F2C_PATH)/*.c)))

DRIVER_OBJS    := $(sort $(patsubst $(DRIVER_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(DRIVER_PATH)/*.c)))

# Extract base names for each test driver file.
DRIVER_BASES   := $(basename $(notdir $(DRIVER_OBJS)))

# Binary executable names.
DRIVER_BINS    := $(addsuffix .x,$(DRIVER_BASES))

# Binary run-rule names
DRIVER_BINS_R  := $(addprefix run-,$(DRIVER_BASES))

# Filter level-1, level-2, and level-3 names to different variables.
DRIVER1_BASES  := $(filter %1,$(DRIVER_BASES))
DRIVER2_BASES  := $(filter %2,$(DRIVER_BASES))
DRIVER3_BASES  := $(filter %3,$(DRIVER_BASES))

# The location of the script that checks the BLAS test output.
#BLASTEST_CHECK := $(DIST_PATH)/$(BUILD_DIR)/check-blastest.sh

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Suppress warnings about uninitialized functions, add local header
# paths and the path to blis.h to CFLAGS.
CFLAGS         += -Wno-maybe-uninitialized -Wno-parentheses -Wfatal-errors \
                  -I$(F2C_PATH) \
                  -I$(INC_PATH) -DHAVE_BLIS_H

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Override the location of the check-blastest.sh script.
#BLASTEST_CHECK := ./check-blastest.sh

TESTSUITE_WRAPPER       ?=

#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: check-env f2c bin

f2c: check-env $(F2C_LIB)

bin: check-env $(DRIVER_BINS)


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(F2C_PATH)/%.c
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif

$(TEST_OBJ_PATH)/%.o: $(DRIVER_PATH)/%.c
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- libf2c library archive rule --

$(F2C_LIB): $(F2C_OBJS)
ifeq ($(ENABLE_VERBOSE),yes)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
else
	@echo "Archiving $@"
	@$(AR) $(ARFLAGS) $@ $?
	@$(RANLIB) $@
endif


# -- Executable file rules --

# first argument: the base name of the BLAS test driver.
define make-blat-rule
$(1).x: $(TEST_OBJ_PATH)/$(1).o $(F2C_LIB) $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $(TEST_OBJ_PATH)/$(1).o $(F2C_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $$@
else
	@echo "Linking $$@ against '$(F2C_LIB) $(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $(TEST_OBJ_PATH)/$(1).o $(F2C_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $$@
endif
endef

# Instantiate the rule above for each driver file.
$(foreach name, $(DRIVER_BASES), $(eval $(call make-blat-rule,$(name))))


# -- Test run rules --

run: $(DRIVER_BINS_R)

# A rule to run ?blat1.x driver files.
define make-run-blat1-rule
run-$(1): $(1).x
ifeq ($(ENABLE_VERBOSE),yes)
	$(TESTSUITE_WRAPPER) ./$(1).x > out.$(1)
else
	@echo "Running $(1).x > 'out.$(1)'"
	@$(TESTSUITE_WRAPPER) ./$(1).x > out.$(1)
endif
endef

# Instantiate the rule above for each level-1 driver file.
$(foreach name, $(DRIVER1_BASES), $(eval $(call make-run-blat1-rule,$(name))))

# A rule to run ?blat2.x and ?blat3.x driver files.
define make-run-blat23-rule
run-$(1): $(1).x
ifeq ($(ENABLE_VERBOSE),yes)
	$(TESTSUITE_WRAPPER) ./$(1).x < $(INPUT_DIR)/$(1).in
else
	@echo "Running $(1).x < '$(INPUT_DIR)/$(1).in' (output to 'out.$(1)')"
	@$(TESTSUITE_WRAPPER) ./$(1).x < $(INPUT_DIR)/$(1).in
endif
endef

# Instantiate the rule above for each level-2 driver file.
$(foreach name, $(DRIVER2_BASES), $(eval $(call make-run-blat23-rule,$(name))))

# Instantiate the rule above for each level-3 driver file.
$(foreach name, $(DRIVER3_BASES), $(eval $(call make-run-blat23-rule,$(name))))

check: run
ifeq ($(ENABLE_VERBOSE),yes)
	- $(BLASTEST_CHECK)
else
	@- $(BLASTEST_CHECK)
endif


# -- Clean rules --

cleanf2c:
	- $(RM_F) $(F2C_OBJS) $(F2C_LIB)

cleanobj:
	- $(RM_F) $(DRIVER_OBJS)

cleanbin:
	- $(RM_F) $(DRIVER_BINS)

cleanout:
	- $(RM_F) $(addprefix out.,$(DRIVER_BASES))

clean: cleanf2c cleanobj cleanbin cleanout

=== examples/Makefile ===
dlvl = ./.
include $(dlvl)/../Makefile.in

all: example1 example2

example1: 
	$(CC) -c $(CFLAGS) -I../src cblas_example1.c
	$(LOADER) -o cblas_ex1 cblas_example1.o $(CBLIB) $(BLLIB)

example2: 
	$(CC) -c $(CFLAGS) -I../src cblas_example2.c
	$(LOADER) -o cblas_ex2 cblas_example2.o $(CBLIB) $(BLLIB)
   
cleanall:
	rm -f *.o cblas_ex1 cblas_ex2

=== src/Makefile ===
# This Makefile compiles the CBLAS routines
#
dlvl = ../.
include $(dlvl)/Makefile.in

#
# Erase all object and archive files
#
clean:
	rm -f *.o a.out core 

# Error handling routines for level 2 & 3

errhand = cblas_globals.o cblas_xerbla.o xerbla.o

# Object files of all routines
alev = $(alev1) $(alev2) $(alev3) $(errhand) 
#
#
# CBLAS routines
#
# Level 1
#
# 

#
# All object files for single real precision
#
slev1 = cblas_srotg.o cblas_srotmg.o cblas_srot.o cblas_srotm.o  \
         cblas_sswap.o cblas_sscal.o  cblas_scopy.o cblas_saxpy.o \
         cblas_sdot.o  cblas_sdsdot.o cblas_snrm2.o cblas_sasum.o \
         cblas_isamax.o   sdotsub.o   sdsdotsub.o snrm2sub.o sasumsub.o \
         isamaxsub.o 
#
# All object files for double real precision
#
dlev1 = cblas_drotg.o cblas_drotmg.o cblas_drot.o cblas_drotm.o  \
         cblas_dswap.o cblas_dscal.o  cblas_dcopy.o cblas_daxpy.o \
         cblas_ddot.o  cblas_dsdot.o cblas_dnrm2.o cblas_dasum.o  \
         cblas_idamax.o   ddotsub.o   dsdotsub.o       dnrm2sub.o \
         dasumsub.o idamaxsub.o

#
# All object files for single complex precision
#
clev1 = cblas_cswap.o cblas_cscal.o cblas_csscal.o cblas_ccopy.o \
         cblas_caxpy.o cblas_cdotu_sub.o cblas_cdotc_sub.o \
         cblas_icamax.o cdotcsub.o cdotusub.o icamaxsub.o 

#
# All object files for double complex precision
#
zlev1 = cblas_zswap.o cblas_zscal.o cblas_zdscal.o cblas_zcopy.o \
         cblas_zaxpy.o cblas_zdotu_sub.o cblas_zdotc_sub.o cblas_dznrm2.o \
         cblas_dzasum.o cblas_izamax.o zdotcsub.o zdotusub.o      \
         dzasumsub.o  dznrm2sub.o  izamaxsub.o 

#
# Common files for single / complex precision
#
sclev1 = cblas_scasum.o scasumsub.o cblas_scnrm2.o scnrm2sub.o

#
# All object files
#
alev1 = $(slev1) $(dlev1) $(clev1) $(zlev1) $(sclev1)


#
# Make an archive file
#

# Single real precision
slib1: $(slev1) $(sclev1)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(slev1) $(sclev1)
	$(RANLIB) $(CBLIB)

# Double real precision
dlib1: $(dlev1) 
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(dlev1)
	$(RANLIB) $(CBLIB)

# Single complex precision
clib1: $(clev1) $(sclev1)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(clev1) $(sclev1)
	$(RANLIB) $(CBLIB)

# Double complex precision
zlib1: $(zlev1)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(zlev1)
	$(RANLIB) $(CBLIB)

# All precisions
all1:  $(alev1)
	$(ARCH) $(ARCHFLAGS)  $(CBLIB) $(alev1)
	$(RANLIB) $(CBLIB)

#
#
# CBLAS routines
#
# Level 2
#
# 

#
# All object files for single real precision
#
slev2 = cblas_sgemv.o cblas_sgbmv.o cblas_sger.o cblas_ssbmv.o  cblas_sspmv.o \
        cblas_sspr.o  cblas_sspr2.o cblas_ssymv.o cblas_ssyr.o  cblas_ssyr2.o \
        cblas_stbmv.o cblas_stbsv.o cblas_stpmv.o cblas_stpsv.o  cblas_strmv.o \
        cblas_strsv.o  
 
#
# All object files for double real precision
#
dlev2 = cblas_dgemv.o cblas_dgbmv.o cblas_dger.o cblas_dsbmv.o  cblas_dspmv.o \
        cblas_dspr.o  cblas_dspr2.o cblas_dsymv.o cblas_dsyr.o  cblas_dsyr2.o \
        cblas_dtbmv.o cblas_dtbsv.o cblas_dtpmv.o cblas_dtpsv.o  cblas_dtrmv.o \
        cblas_dtrsv.o  

#
# All object files for single complex precision
#
clev2 = cblas_cgemv.o cblas_cgbmv.o cblas_chemv.o cblas_chbmv.o cblas_chpmv.o \
        cblas_ctrmv.o cblas_ctbmv.o cblas_ctpmv.o cblas_ctrsv.o cblas_ctbsv.o \
        cblas_ctpsv.o cblas_cgeru.o cblas_cgerc.o cblas_cher.o  cblas_cher2.o \
        cblas_chpr.o  cblas_chpr2.o 

#
# All object files for double complex precision
#
zlev2 = cblas_zgemv.o cblas_zgbmv.o cblas_zhemv.o cblas_zhbmv.o cblas_zhpmv.o \
        cblas_ztrmv.o cblas_ztbmv.o cblas_ztpmv.o cblas_ztrsv.o cblas_ztbsv.o \
        cblas_ztpsv.o cblas_zgeru.o cblas_zgerc.o cblas_zher.o  cblas_zher2.o \
        cblas_zhpr.o  cblas_zhpr2.o 
#
# All object files
#
alev2 = $(slev2) $(dlev2) $(clev2) $(zlev2)

#
# Make an archive file
#

# Single real precision
slib2: $(slev2) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(slev2) $(errhand)
	$(RANLIB) $(CBLIB)

# Double real  precision
dlib2: $(dlev2) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(dlev2) $(errhand)
	$(RANLIB) $(CBLIB)

# Single complex precision
clib2: $(clev2) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(clev2) $(errhand)
	$(RANLIB) $(CBLIB)

# Double complex precision
zlib2: $(zlev2) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(zlev2) $(errhand)
	$(RANLIB) $(CBLIB)

# All precisions
all2:  $(alev2) $(errhand)
	$(ARCH) $(ARCHFLAGS)  $(CBLIB) $(alev2) $(errhand)
	$(RANLIB) $(CBLIB)
#
#
# CBLAS routines
#
# Level 3
#
# 

#
# All object files for single real precision
#
slev3 = cblas_sgemm.o cblas_ssymm.o cblas_ssyrk.o cblas_ssyr2k.o cblas_strmm.o\
        cblas_strsm.o
 
#
# All object files for double real precision
#
dlev3 = cblas_dgemm.o cblas_dsymm.o cblas_dsyrk.o cblas_dsyr2k.o cblas_dtrmm.o\
        cblas_dtrsm.o  

#
# All object files for single complex precision
#
clev3 = cblas_cgemm.o cblas_csymm.o cblas_chemm.o cblas_cherk.o\
        cblas_cher2k.o cblas_ctrmm.o cblas_ctrsm.o  cblas_csyrk.o\
        cblas_csyr2k.o
#
# All object files for double complex precision
#
zlev3 = cblas_zgemm.o cblas_zsymm.o cblas_zhemm.o cblas_zherk.o\
        cblas_zher2k.o cblas_ztrmm.o cblas_ztrsm.o  cblas_zsyrk.o\
        cblas_zsyr2k.o
#
# All object files
#
alev3 = $(slev3) $(dlev3) $(clev3) $(zlev3)

#
# Make an archive file
#

# Single real precision
slib3: $(slev3) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(slev3) $(errhand)
	$(RANLIB) $(CBLIB)

# Double real precision
dlib3: $(dlev3) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(dlev3) $(errhand)
	$(RANLIB) $(CBLIB)

# Single complex precision
clib3: $(clev3) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(clev3) $(errhand)
	$(RANLIB) $(CBLIB)

# Single complex precision
zlib3: $(zlev3) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(zlev3) $(errhand)
	$(RANLIB) $(CBLIB)

# All precisions
all3:  $(alev3) $(errhand)
	$(ARCH) $(ARCHFLAGS) $(CBLIB) $(alev3) 
	$(RANLIB) $(CBLIB)

# All levels and precisions
all: $(alev)  
	$(ARCH) $(ARCHFLAGS)  $(CBLIB) $(alev) 
	$(RANLIB) $(CBLIB)


.SUFFIXES: .o .c .f

.c.o:
	$(CC) $(CFLAGS) -I../include -c $*.c
.f.o:
	$(FC) $(FFLAGS) -c $*.f

=== testing/Makefile ===
#
# The Makefile compiles c wrappers and testers for CBLAS.  
#

dlvl = ../.
include $(dlvl)/Makefile.in

# Archive files necessary to compile
LIB = $(CBLIB) $(BLLIB) 

# Object files for single real precision
stestl1o = c_sblas1.o

stestl2o = c_sblas2.o c_s2chke.o auxiliary.o c_xerbla.o

stestl3o = c_sblas3.o c_s3chke.o auxiliary.o c_xerbla.o

# Object files for double real precision
dtestl1o = c_dblas1.o

dtestl2o = c_dblas2.o c_d2chke.o auxiliary.o c_xerbla.o

dtestl3o = c_dblas3.o c_d3chke.o auxiliary.o c_xerbla.o

# Object files for single complex precision
ctestl1o = c_cblas1.o

ctestl2o = c_cblas2.o c_c2chke.o auxiliary.o c_xerbla.o

ctestl3o = c_cblas3.o c_c3chke.o auxiliary.o c_xerbla.o

# Object files for double complex precision
ztestl1o = c_zblas1.o 

ztestl2o = c_zblas2.o c_z2chke.o auxiliary.o c_xerbla.o

ztestl3o = c_zblas3.o c_z3chke.o auxiliary.o c_xerbla.o

all: all1 all2 all3 
all1: stest1 dtest1 ctest1 ztest1 
all2: stest2 dtest2 ctest2 ztest2
all3: stest3 dtest3 ctest3 ztest3

clean:
	rm -f core *.o a.out x*
cleanobj:
	rm -f core *.o a.out 
cleanexe:
	rm -f x* 

stest1: xscblat1
dtest1: xdcblat1
ctest1: xccblat1
ztest1: xzcblat1

stest2: xscblat2
dtest2: xdcblat2
ctest2: xccblat2
ztest2: xzcblat2

stest3: xscblat3
dtest3: xdcblat3
ctest3: xccblat3
ztest3: xzcblat3

#
# Compile each precision
#

# Single real
xscblat1: $(stestl1o) c_sblat1.o
	$(LOADER) $(LOADFLAGS) -o xscblat1 c_sblat1.o $(stestl1o) $(LIB)
xscblat2: $(stestl2o) c_sblat2.o
	$(LOADER) $(LOADFLAGS) -o xscblat2 c_sblat2.o $(stestl2o) $(LIB)
xscblat3: $(stestl3o) c_sblat3.o
	$(LOADER) $(LOADFLAGS) -o xscblat3 c_sblat3.o $(stestl3o) $(LIB)
# Double real
xdcblat1: $(dtestl1o) c_dblat1.o
	$(LOADER) $(LOADFLAGS) -o xdcblat1 c_dblat1.o $(dtestl1o) $(LIB)
xdcblat2: $(dtestl2o) c_dblat2.o
	$(LOADER) $(LOADFLAGS) -o xdcblat2 c_dblat2.o $(dtestl2o) $(LIB)
xdcblat3: $(dtestl3o) c_dblat3.o
	$(LOADER) $(LOADFLAGS) -o xdcblat3 c_dblat3.o $(dtestl3o) $(LIB)
 
# Single complex
xccblat1: $(ctestl1o) c_cblat1.o
	$(LOADER) $(LOADFLAGS) -o xccblat1 c_cblat1.o $(ctestl1o) $(LIB)
xccblat2: $(ctestl2o) c_cblat2.o
	$(LOADER) $(LOADFLAGS) -o xccblat2 c_cblat2.o $(ctestl2o) $(LIB)
xccblat3: $(ctestl3o) c_cblat3.o
	$(LOADER) $(LOADFLAGS) -o xccblat3 c_cblat3.o $(ctestl3o) $(LIB)

# Double complex 
xzcblat1: $(ztestl1o) c_zblat1.o
	$(LOADER) $(LOADFLAGS) -o xzcblat1 c_zblat1.o $(ztestl1o) $(LIB)
xzcblat2: $(ztestl2o) c_zblat2.o
	$(LOADER) $(LOADFLAGS) -o xzcblat2 c_zblat2.o $(ztestl2o) $(LIB)
xzcblat3: $(ztestl3o) c_zblat3.o
	$(LOADER) $(LOADFLAGS) -o xzcblat3 c_zblat3.o $(ztestl3o) $(LIB)
   

# RUN TESTS
run:
	@echo "--> TESTING BLAS 1 - SINGLE PRECISION <--"
	@./xscblat1 > stest1.out
	@echo "--> TESTING BLAS 1 - DOUBLE PRECISION <--"
	@./xdcblat1  > dtest1.out
	@echo "--> TESTING BLAS 1 - COMPLEX PRECISION <--"
	@./xccblat1  > ctest1.out
	@echo "--> TESTING BLAS 1 - DOUBLE COMPLEX PRECISION <--"
	@./xzcblat1	 > ztest1.out
	@echo "--> TESTING BLAS 2 - SINGLE PRECISION <--"
	@./xscblat2 < sin2 > stest2.out
	@echo "--> TESTING BLAS 2 - DOUBLE PRECISION <--"
	@./xdcblat2 < din2 > dtest2.out
	@echo "--> TESTING BLAS 2 - COMPLEX PRECISION <--"
	@./xccblat2 < cin2 > ctest2.out
	@echo "--> TESTING BLAS 2 - DOUBLE COMPLEX PRECISION <--"
	@./xzcblat2	< zin2	> ztest2.out
	@echo "--> TESTING BLAS 3 - SINGLE PRECISION <--"
	@./xscblat3 < sin3 > stest3.out
	@echo "--> TESTING BLAS 3 - DOUBLE PRECISION <--"
	@./xdcblat3 < din3 > dtest3.out
	@echo "--> TESTING BLAS 3 - COMPLEX PRECISION <--"
	@./xccblat3 < cin3 > ctest3.out
	@echo "--> TESTING BLAS 3 - DOUBLE COMPLEX PRECISION <--"
	@./xzcblat3	< zin3 > ztest3.out	
	
.SUFFIXES: .o .f .c

.f.o:
	$(FC) $(FFLAGS) -c $*.f
.c.o:
	$(CC) -I../include $(CFLAGS) -c $*.c

=== test/1m4m/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2018, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS implementations -----------------------------------------------------
#

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# ATLAS
#ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
#                  $(HOME_LIB_PATH)/libatlas.a

# Eigen
EIGEN_INC      := $(HOME)/flame/eigen/include/eigen3
EIGEN_LIB      := $(HOME_LIB_PATH)/libeigen_blas_static.a
EIGENP_LIB     := $(EIGEN_LIB)

# MKL
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

VENDOR_LIB     := $(MKL_LIB)
VENDORP_LIB    := $(MKLP_LIB)


#
# --- Problem size definitions -------------------------------------------------
#

# Single core (single-threaded)
PS_BEGIN := 48
PS_MAX   := 2400
PS_INC   := 48

# Single-socket (multithreaded)
P1_BEGIN := 96
P1_MAX   := 4800
P1_INC   := 96

# Dual-socket (multithreaded)
P2_BEGIN := 144
P2_MAX   := 7200
P2_INC   := 144


#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Define a set of CFLAGS for use with C++ and Eigen.
CXXFLAGS       := $(subst -std=c99,-std=c++11,$(CFLAGS))
CXXFLAGS       += -I$(EIGEN_INC)

# Create a copy of CXXFLAGS without -fopenmp in order to disable multithreading.
CXXFLAGS_ST    := -march=native $(subst -fopenmp,,$(CXXFLAGS))
CXXFLAGS_MT    := -march=native $(CXXFLAGS)


# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS
EIG_DEF  := -DEIGEN

# Complex implementation type
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
STR_1M   := -DSTR=\"1m_blis\"
STR_NAT  := -DSTR=\"asm_blis\"
STR_OBL  := -DSTR=\"openblas\"
STR_EIG  := -DSTR=\"eigen\"
STR_VEN  := -DSTR=\"vendor\"

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_1S   := -DTHR_STR=\"1s\"
STR_2S   := -DTHR_STR=\"2s\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=$(PS_BEGIN)  -DP_INC=$(PS_INC)  -DP_MAX=$(PS_MAX)
PDEF_1S  := -DP_BEGIN=$(P1_BEGIN) -DP_INC=$(P1_INC) -DP_MAX=$(P1_MAX)
PDEF_2S  := -DP_BEGIN=$(P2_BEGIN) -DP_INC=$(P2_INC) -DP_MAX=$(P2_MAX)



#
# --- Targets/rules ------------------------------------------------------------
#

all:        all-st all-1s all-2s
blis:       blis-st blis-1s blis-2s
openblas:   openblas-st openblas-1s openblas-2s
eigen:      eigen-st eigen-1s eigen-2s
vendor:     vendor-st vendor-1s vendor-2s
mkl:        vendor
armpl:      vendor

all-st:     blis-st openblas-st mkl-st
all-1s:     blis-1s openblas-1s mkl-1s
all-2s:     blis-2s openblas-2s mkl-2s

blis-st:    blis-nat-st blis-1m-st
blis-1s:    blis-nat-1s blis-1m-1s
blis-2s:    blis-nat-2s blis-1m-2s

#blis-ind:   blis-ind-st blis-ind-mt
blis-nat:   blis-nat-st  blis-nat-1s  blis-nat-2s
blis-1m:    blis-1m-st   blis-1m-1s   blis-1m-2s

# Define the datatypes, operations, and implementations.
DTS    := s d c z
OPS    := gemm
BIMPLS := asm_blis 1m_blis openblas vendor
EIMPLS := eigen

# Define functions to construct object filenames from the datatypes and
# operations given an implementation. We define one function for single-
# threaded, single-socket, and dual-socket filenames.
get-st-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(PS_MAX)_$(1)_st.o))
get-1s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P1_MAX)_$(1)_1s.o))
get-2s-objs = $(foreach dt,$(DTS),$(foreach op,$(OPS),test_$(dt)$(op)_$(P2_MAX)_$(1)_2s.o))

# Construct object and binary names for single-threaded, single-socket, and
# dual-socket files for BLIS, OpenBLAS, and a vendor library (e.g. MKL).
BLIS_1M_ST_OBJS := $(call get-st-objs,1m_blis)
BLIS_1M_ST_BINS := $(patsubst %.o,%.x,$(BLIS_1M_ST_OBJS))
BLIS_1M_1S_OBJS := $(call get-1s-objs,1m_blis)
BLIS_1M_1S_BINS := $(patsubst %.o,%.x,$(BLIS_1M_1S_OBJS))
BLIS_1M_2S_OBJS := $(call get-2s-objs,1m_blis)
BLIS_1M_2S_BINS := $(patsubst %.o,%.x,$(BLIS_1M_2S_OBJS))

BLIS_NAT_ST_OBJS := $(call get-st-objs,asm_blis)
BLIS_NAT_ST_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_ST_OBJS))
BLIS_NAT_1S_OBJS := $(call get-1s-objs,asm_blis)
BLIS_NAT_1S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_1S_OBJS))
BLIS_NAT_2S_OBJS := $(call get-2s-objs,asm_blis)
BLIS_NAT_2S_BINS := $(patsubst %.o,%.x,$(BLIS_NAT_2S_OBJS))

OPENBLAS_ST_OBJS := $(call get-st-objs,openblas)
OPENBLAS_ST_BINS := $(patsubst %.o,%.x,$(OPENBLAS_ST_OBJS))
OPENBLAS_1S_OBJS := $(call get-1s-objs,openblas)
OPENBLAS_1S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_1S_OBJS))
OPENBLAS_2S_OBJS := $(call get-2s-objs,openblas)
OPENBLAS_2S_BINS := $(patsubst %.o,%.x,$(OPENBLAS_2S_OBJS))

EIGEN_ST_OBJS    := $(call get-st-objs,eigen)
EIGEN_ST_BINS    := $(patsubst %.o,%.x,$(EIGEN_ST_OBJS))
EIGEN_1S_OBJS    := $(call get-1s-objs,eigen)
EIGEN_1S_BINS    := $(patsubst %.o,%.x,$(EIGEN_1S_OBJS))
EIGEN_2S_OBJS    := $(call get-2s-objs,eigen)
EIGEN_2S_BINS    := $(patsubst %.o,%.x,$(EIGEN_2S_OBJS))

VENDOR_ST_OBJS   := $(call get-st-objs,vendor)
VENDOR_ST_BINS   := $(patsubst %.o,%.x,$(VENDOR_ST_OBJS))
VENDOR_1S_OBJS   := $(call get-1s-objs,vendor)
VENDOR_1S_BINS   := $(patsubst %.o,%.x,$(VENDOR_1S_OBJS))
VENDOR_2S_OBJS   := $(call get-2s-objs,vendor)
VENDOR_2S_BINS   := $(patsubst %.o,%.x,$(VENDOR_2S_OBJS))

# Define some targets associated with the above object/binary files.
blis-nat-st: $(BLIS_NAT_ST_BINS)
blis-nat-1s: $(BLIS_NAT_1S_BINS)
blis-nat-2s: $(BLIS_NAT_2S_BINS)

blis-1m-st: $(BLIS_1M_ST_BINS)
blis-1m-1s: $(BLIS_1M_1S_BINS)
blis-1m-2s: $(BLIS_1M_2S_BINS)

openblas-st: $(OPENBLAS_ST_BINS)
openblas-1s: $(OPENBLAS_1S_BINS)
openblas-2s: $(OPENBLAS_2S_BINS)

eigen-st: $(EIGEN_ST_BINS)
eigen-1s: $(EIGEN_1S_BINS)
eigen-2s: $(EIGEN_2S_BINS)

vendor-st: $(VENDOR_ST_BINS)
vendor-1s: $(VENDOR_1S_BINS)
vendor-2s: $(VENDOR_2S_BINS)

mkl-st: vendor-st
mkl-1s: vendor-1s
mkl-2s: vendor-2s

armpl-st: vendor-st
armpl-1s: vendor-1s
armpl-2s: vendor-2s

# Mark the object files as intermediate so that make will remove them
# automatically after building the binaries on which they depend.
.INTERMEDIATE: $(BLIS_NAT_ST_OBJS) $(BLIS_NAT_1S_OBJS) $(BLIS_NAT_2S_OBJS)
.INTERMEDIATE: $(BLIS_1M_ST_OBJS)  $(BLIS_1M_1S_OBJS)  $(BLIS_1M_2S_OBJS)
.INTERMEDIATE: $(OPENBLAS_ST_OBJS) $(OPENBLAS_1S_OBJS) $(OPENBLAS_2S_OBJS)
.INTERMEDIATE: $(EIGEN_ST_OBJS)    $(EIGEN_1S_OBJS)    $(EIGEN_2S_OBJS)
.INTERMEDIATE: $(VENDOR_ST_OBJS)   $(VENDOR_1S_OBJS)   $(VENDOR_2S_OBJS)


# --Object file rules --

#$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
#	$(CC) $(CFLAGS) -c $< -o $@

# A function to return the datatype cpp macro def from the datatype
# character.
get-dt-cpp = $(strip \
             $(if $(findstring s,$(1)),-DDT=BLIS_FLOAT    -DIS_FLOAT,\
             $(if $(findstring d,$(1)),-DDT=BLIS_DOUBLE   -DIS_DOUBLE,\
             $(if $(findstring c,$(1)),-DDT=BLIS_SCOMPLEX -DIS_SCOMPLEX,\
                                       -DDT=BLIS_DCOMPLEX -DIS_DCOMPLEX))))

get-in-cpp = $(strip \
             $(if $(findstring   1m_blis,$(1)),-DIND=BLIS_1M,\
                                               -DIND=BLIS_NAT))

# A function to return other cpp macros that help the test driver
# identify the implementation.
#get-bl-cpp = $(strip \
#             $(if $(findstring     blis,$(1)),$(STR_NAT) $(BLI_DEF),\
#             $(if $(findstring openblas,$(1)),$(STR_OBL) $(BLA_DEF),\
#             $(if $(findstring    eigen,$(1)),$(STR_EIG) $(EIG_DEF),\
#                                              $(STR_VEN) $(BLA_DEF)))))

get-bl-cpp = $(strip \
             $(if $(findstring   1m_blis,$(1)),$(STR_1M) $(BLI_DEF),\
             $(if $(findstring  asm_blis,$(1)),$(STR_NAT) $(BLI_DEF),\
             $(if $(findstring  openblas,$(1)),$(STR_OBL) $(BLA_DEF),\
             $(if $(and $(findstring eigen,$(1)),\
                        $(findstring  gemm,$(2))),\
                                              $(STR_EIG) $(EIG_DEF),\
             $(if       $(findstring eigen,$(1)),\

=== test/3/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2018, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        check-env check-env-mk check-lib \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS implementations -----------------------------------------------------
#

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# ATLAS
#ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
#                  $(HOME_LIB_PATH)/libatlas.a

# Eigen
EIGEN_INC      := $(HOME)/flame/eigen/include/eigen3
EIGEN_LIB      := $(HOME_LIB_PATH)/libeigen_blas_static.a
EIGENP_LIB     := $(EIGEN_LIB)

# MKL
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

VENDOR_LIB     := $(MKL_LIB)
VENDORP_LIB    := $(MKLP_LIB)



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Define a set of CFLAGS for use with C++ and Eigen.
CXXFLAGS       := $(subst -std=c99,-std=c++11,$(CFLAGS))
CXXFLAGS       += -I$(EIGEN_INC)

# Create a copy of CXXFLAGS without -fopenmp in order to disable multithreading.
CXXFLAGS_ST    := -march=native $(subst -fopenmp,,$(CXXFLAGS))
CXXFLAGS_MT    := -march=native $(CXXFLAGS)


# Which library?
DEF_BLI  := -DBLIS
DEF_BLA  := -DBLAS
DEF_EIG  := -DEIGEN

# Implementation string.
STR_BLI  := -DIMPL_STR=\"blis\"
STR_OBL  := -DIMPL_STR=\"openblas\"
STR_EIG  := -DIMPL_STR=\"eigen\"
STR_VEN  := -DIMPL_STR=\"vendor\"

# Single or multithreaded string.
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"



#
# --- Targets/rules ------------------------------------------------------------
#

all:      all-st

all-st:   blis-st openblas-st mkl-st eigen-st
all-mt:   blis-mt openblas-mt mkl-mt eigen-mt

blis:     blis-st
openblas: openblas-st
eigen:    eigen-st
vendor:   vendor-st
mkl:      mkl-st

# Define the datatypes, operations, and implementations.
OPS    := gemm hemm herk trmm trsm
BIMPLS := blis openblas vendor
EIMPLS := eigen

# Define a function to construct object filenames from the operations
# given an implementation.
get-st-objs = $(foreach op,$(OPS),test_$(op)_$(1)_st.o)
get-mt-objs = $(foreach op,$(OPS),test_$(op)_$(1)_mt.o)

# Construct object and binary names for single-threaded and multithreaded
# files for BLIS, OpenBLAS, Eigen, and a vendor library (e.g. MKL).
BLIS_ST_OBJS     := $(call get-st-objs,blis)
BLIS_ST_BINS     := $(patsubst %.o,%.x,$(BLIS_ST_OBJS))

BLIS_MT_OBJS     := $(call get-mt-objs,blis)
BLIS_MT_BINS     := $(patsubst %.o,%.x,$(BLIS_MT_OBJS))

OPENBLAS_ST_OBJS := $(call get-st-objs,openblas)
OPENBLAS_ST_BINS := $(patsubst %.o,%.x,$(OPENBLAS_ST_OBJS))

OPENBLAS_MT_OBJS := $(call get-mt-objs,openblas)
OPENBLAS_MT_BINS := $(patsubst %.o,%.x,$(OPENBLAS_MT_OBJS))

EIGEN_ST_OBJS    := $(call get-st-objs,eigen)
EIGEN_ST_BINS    := $(patsubst %.o,%.x,$(EIGEN_ST_OBJS))

EIGEN_MT_OBJS    := $(call get-mt-objs,eigen)
EIGEN_MT_BINS    := $(patsubst %.o,%.x,$(EIGEN_MT_OBJS))

VENDOR_ST_OBJS   := $(call get-st-objs,vendor)
VENDOR_ST_BINS   := $(patsubst %.o,%.x,$(VENDOR_ST_OBJS))

VENDOR_MT_OBJS   := $(call get-mt-objs,vendor)
VENDOR_MT_BINS   := $(patsubst %.o,%.x,$(VENDOR_MT_OBJS))

# List other miscellaneous object files
UTIL_OBJS        := test_utils.o
UTIL_HDRS        := test_utils.h

# Define some targets associated with the above object/binary files.
blis-st:     check-env $(BLIS_ST_BINS)
blis-mt:     check-env $(BLIS_MT_BINS)
openblas-st: check-env $(OPENBLAS_ST_BINS)
openblas-mt: check-env $(OPENBLAS_MT_BINS)
eigen-st:    check-env $(EIGEN_ST_BINS)
eigen-mt:    check-env $(EIGEN_MT_BINS)
vendor-st:   check-env $(VENDOR_ST_BINS)
vendor-mt:   check-env $(VENDOR_MT_BINS)
mkl-st:      vendor-st
mkl-mt:      vendor-mt
armpl-st:    vendor-st
armpl-mt:    vendor-mt

# Mark the object files as intermediate so that make will remove them
# automatically after building the binaries on which they depend.
.INTERMEDIATE: $(BLIS_ST_OBJS)     $(BLIS_MT_OBJS)
.INTERMEDIATE: $(OPENBLAS_ST_OBJS) $(OPENBLAS_MT_OBJS)
.INTERMEDIATE: $(EIGEN_ST_OBJS)    $(EIGEN_MT_OBJS)
.INTERMEDIATE: $(VENDOR_ST_OBJS)   $(VENDOR_MT_OBJS)
.INTERMEDIATE: $(UTIL_OBJS)


# -- Object file rules --

# A function to return other cpp macros that help the test driver
# identify the implementation.
get-bl-cpp = $(strip \
             $(if $(findstring     blis,$(1)),$(STR_BLI) $(DEF_BLI),\
             $(if $(findstring openblas,$(1)),$(STR_OBL) $(DEF_BLA),\
             $(if $(and $(findstring eigen,$(1)),\
                        $(findstring  gemm,$(2))),\
                                              $(STR_EIG) $(DEF_EIG),\
             $(if       $(findstring eigen,$(1)),\
                                              $(STR_EIG) $(DEF_BLA),\
                                              $(STR_VEN) $(DEF_BLA))))))

# Rules for miscellaneous files.
test_utils.o: test_utils.c test_utils.h
	$(CC) $(CFLAGS) -c $< -o $@

# Rules for BLIS and BLAS libraries.
define make-st-rule
test_$(1)_$(2)_st.o: test_$(op).c Makefile
	$(CC) $(CFLAGS) $(call get-bl-cpp,$(2),$(1)) $(STR_ST) -c $$< -o $$@
endef

define make-mt-rule
test_$(1)_$(2)_mt.o: test_$(op).c Makefile
	$(CC) $(CFLAGS) $(call get-bl-cpp,$(2),$(1)) $(STR_MT) -c $$< -o $$@
endef

$(foreach op,$(OPS), \
$(foreach im,$(BIMPLS),$(eval $(call make-st-rule,$(op),$(im)))))

$(foreach op,$(OPS), \
$(foreach im,$(BIMPLS),$(eval $(call make-mt-rule,$(op),$(im)))))

# Rules for Eigen.
# NOTE: Eigen determines single- vs. multithreadedness at compile time.
define make-eigst-rule
test_$(1)_$(2)_st.o: test_$(op).c Makefile
	$(CXX) $(CXXFLAGS_ST) $(call get-bl-cpp,$(2),$(1)) $(STR_ST) -c $$< -o $$@
endef

define make-eigmt-rule
test_$(1)_$(2)_mt.o: test_$(op).c Makefile
	$(CXX) $(CXXFLAGS_MT) $(call get-bl-cpp,$(2),$(1)) $(STR_MT) -c $$< -o $$@
endef

$(foreach op,$(OPS), \
$(foreach im,$(EIMPLS),$(eval $(call make-eigst-rule,$(op),$(im)))))

$(foreach op,$(OPS), \
$(foreach im,$(EIMPLS),$(eval $(call make-eigmt-rule,$(op),$(im)))))


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

# Combine the miscellaneous objects with libblis for conciseness (since all
# driver binaries depend on these objects).
COMMON_OBJS := $(UTIL_OBJS) $(LIBBLIS_LINK)

test_%_blis_st.x:     test_%_blis_st.o     $(COMMON_OBJS)
	$(CC) $(strip $<                    $(COMMON_OBJS) $(LDFLAGS) -o $@)

test_%_blis_mt.x:     test_%_blis_mt.o     $(COMMON_OBJS)
	$(CC) $(strip $<                    $(COMMON_OBJS) $(LDFLAGS) -o $@)


test_%_openblas_st.x: test_%_openblas_st.o $(COMMON_OBJS)
	$(CC) $(strip $<   $(OPENBLAS_LIB)  $(COMMON_OBJS) $(LDFLAGS) -o $@)

test_%_openblas_mt.x: test_%_openblas_mt.o $(COMMON_OBJS)
	$(CC) $(strip $<   $(OPENBLASP_LIB) $(COMMON_OBJS) $(LDFLAGS) -o $@)


test_%_eigen_st.x:    test_%_eigen_st.o    $(COMMON_OBJS)
	$(CXX) $(strip $<  $(EIGEN_LIB)     $(COMMON_OBJS) $(LDFLAGS) -o $@)

test_%_eigen_mt.x:    test_%_eigen_mt.o    $(COMMON_OBJS)
	$(CXX) $(strip $<  $(EIGENP_LIB)    $(COMMON_OBJS) $(LDFLAGS) -o $@)


test_%_vendor_st.x:   test_%_vendor_st.o   $(COMMON_OBJS)
	$(CC) $(strip $<   $(VENDOR_LIB)    $(COMMON_OBJS) $(LDFLAGS) -o $@)

test_%_vendor_mt.x:   test_%_vendor_mt.o   $(COMMON_OBJS)
	$(CC) $(strip $<   $(VENDORP_LIB)   $(COMMON_OBJS) $(LDFLAGS) -o $@)


# -- Environment check rules --

check-env: check-lib

check-env-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
	$(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-lib: check-env-mk
ifeq ($(wildcard $(LIBBLIS_LINK)),)
	$(error Cannot proceed: BLIS library not yet built! Run make first)
endif


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

=== travis/cxx/Makefile ===
#
#
#  BLIS
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2021, Southern Methodist University
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

.PHONY: all cxx-test

all: cxx-test
	$(CXX) -std=c++0x -o $(BUILD_DIR)/cxx-test.x -I$(INCLUDE_DIR) cxx-test.cxx -L$(LIB_DIR) -lblis

=== sandbox/power10/p10_testsuite/Makefile ===
BLIS_PATH := ../../..

BLIS_INC  := $(BLIS_PATH)/include/power10
BLIS_LIB  := $(BLIS_PATH)/lib/power10/libblis.a

CC := gcc
LINKER := $(CC)

CFLAGS := -I $(BLIS_INC)
LDFLAGS := -lpthread -lm

OBJS      := $(patsubst %.c,%.o, $(wildcard *.c))
PERF_OBJS := performance.o
COR_OBJS  := correctness.o cast_funcs.o

all: performance correctness

$(OBJS): %.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

performance: $(PERF_OBJS)
	$(LINKER) $(PERF_OBJS) $(BLIS_LIB) -o ./gather_perf.x $(LDFLAGS) 

correctness: $(COR_OBJS)
	$(LINKER) $(COR_OBJS) $(BLIS_LIB) -o ./test_correctness.x $(LDFLAGS) 

csv_clean:
	rm -rf *.csv

clean: 
	rm -rf *.x *.o

=== test/studies/skx/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis-gemm-st openblas-gemm-st mkl-gemm-st acml-gemm-st \
        blis-gemm-mt openblas-gemm-mt mkl-gemm-mt acml-gemm-mt \
        blis-syrk-st openblas-syrk-st mkl-syrk-st armpl-syrk-st \
        blis-syrk-mt openblas-syrk-mt mkl-syrk-mt armpl-syrk-mt \
        blis-hemm-st openblas-hemm-st mkl-hemm-st armpl-hemm-st \
        blis-hemm-mt openblas-hemm-mt mkl-hemm-mt armpl-hemm-mt \
        blis-trmm-st openblas-trmm-st mkl-trmm-st armpl-trmm-st \
        blis-trmm-mt openblas-trmm-mt mkl-trmm-mt armpl-trmm-mt \
        clean cleanx



# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../../..
LIB_PATH    = ../../../lib/$(CONFIG_NAME)
INC_PATH    = ../../../include/$(CONFIG_NAME)
SHARE_PATH := ../../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/OpenBLAS/lib
#MKL_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/mkl/lib/intel64
#MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB_PATH   := ${MKLROOT}/lib/intel64
ARMPL_LIB_PATH := /opt/arm/armpl-18.3.0_Cortex-A57_Ubuntu-16.04_gcc_7.1.0_aarch64-linux/lib
#ICC_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/compiler/lib/intel64
ACML_LIB_PATH  := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_int64/lib
ACMLP_LIB_PATH := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_mp_int64/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblas.a

# ATLAS
ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
                  $(HOME_LIB_PATH)/libatlas.a

# For ARMPL
ARMPL_LIB        := $(ARMPL_LIB_PATH)/libarmpl_lp64.a
ARMPLP_LIB       := $(ARMPL_LIB_PATH)/libarmpl_lp64_mp.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

# ACML
ACML_LIB       := -L$(ACML_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml
ACMLP_LIB      := -L$(ACMLP_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml_mp



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -g -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Datatype
DT_S     := -DDT=BLIS_FLOAT
DT_D     := -DDT=BLIS_DOUBLE
DT_C     := -DDT=BLIS_SCOMPLEX
DT_Z     := -DDT=BLIS_DCOMPLEX

# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Complex implementation type
D3MHW    := -DIND=BLIS_3MH
D3M1     := -DIND=BLIS_3M1
D4MHW    := -DIND=BLIS_4MH
D4M1B    := -DIND=BLIS_4M1B
D4M1A    := -DIND=BLIS_4M1A
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
STR_3MHW := -DSTR=\"3mhw\"
STR_3M1  := -DSTR=\"3m1\"
STR_4MHW := -DSTR=\"4mhw\"
STR_4M1B := -DSTR=\"4m1b\"
STR_4M1A := -DSTR=\"4m1a\"
STR_1M   := -DSTR=\"1m\"
STR_NAT  := -DSTR=\"asm\"
STR_OBL  := -DSTR=\"openblas\"
STR_MKL  := -DSTR=\"mkl\"
STR_ACML := -DSTR=\"acml\"
STR_ARMPL:= -DSTR=\"armpl\"


# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=40 \
            -DP_END=2000 \
            -DP_INC=40

PDEF_MT  := -DP_BEGIN=200 \
            -DP_END=5000 \
            -DP_INC=200



#
# --- Targets/rules ------------------------------------------------------------
#

all-st:      blis-st openblas-st mkl-st
all-mt:      blis-mt openblas-mt mkl-mt

blis-st:     blis-gemm-st blis-syrk-st blis-hemm-st blis-trmm-st
blis-mt:     blis-gemm-mt blis-syrk-mt blis-hemm-mt blis-trmm-mt

openblas-st: openblas-gemm-st openblas-syrk-st openblas-hemm-st openblas-trmm-st
openblas-mt: openblas-gemm-mt openblas-syrk-mt openblas-hemm-mt openblas-trmm-mt

mkl-st:      mkl-gemm-st mkl-syrk-st mkl-hemm-st mkl-trmm-st
mkl-mt:      mkl-gemm-mt mkl-syrk-mt mkl-hemm-mt mkl-trmm-mt

armpl-st:      armpl-gemm-st armpl-syrk-st armpl-hemm-st armpl-trmm-st
armpl-mt:      armpl-gemm-mt armpl-syrk-mt armpl-hemm-mt armpl-trmm-mt

blis-gemm-st: \
      test_sgemm_asm_blis_st.x \
      test_dgemm_asm_blis_st.x \
      \
      test_cgemm_1m_blis_st.x \
      test_zgemm_1m_blis_st.x \
      test_cgemm_asm_blis_st.x \
      test_zgemm_asm_blis_st.x

blis-syrk-st: \
      test_ssyrk_asm_blis_st.x \
      test_dsyrk_asm_blis_st.x \
      test_csyrk_1m_blis_st.x \
      test_zsyrk_1m_blis_st.x

blis-syrk-mt: \
      test_ssyrk_asm_blis_mt.x \
      test_dsyrk_asm_blis_mt.x \
      test_csyrk_1m_blis_mt.x \
      test_zsyrk_1m_blis_mt.x

blis-hemm-st: \
      test_shemm_asm_blis_st.x \
      test_dhemm_asm_blis_st.x \
      test_chemm_1m_blis_st.x \
      test_zhemm_1m_blis_st.x

blis-hemm-mt: \
      test_shemm_asm_blis_mt.x \
      test_dhemm_asm_blis_mt.x \
      test_chemm_1m_blis_mt.x \
      test_zhemm_1m_blis_mt.x

blis-trmm-st: \
      test_strmm_asm_blis_st.x \
      test_dtrmm_asm_blis_st.x \
      test_ctrmm_1m_blis_st.x \
      test_ztrmm_1m_blis_st.x

blis-trmm-mt: \
      test_strmm_asm_blis_mt.x \
      test_dtrmm_asm_blis_mt.x \
      test_ctrmm_1m_blis_mt.x \
      test_ztrmm_1m_blis_mt.x 


blis-gemm-mt: \
      test_sgemm_asm_blis_mt.x \
      test_dgemm_asm_blis_mt.x \
      \
      test_cgemm_1m_blis_mt.x \
      test_zgemm_1m_blis_mt.x \
      test_cgemm_asm_blis_mt.x \
      test_zgemm_asm_blis_mt.x

openblas-gemm-st: \
      test_sgemm_openblas_st.x \
      test_dgemm_openblas_st.x \
      test_cgemm_openblas_st.x \
      test_zgemm_openblas_st.x

openblas-gemm-mt: \
      test_sgemm_openblas_mt.x \
      test_dgemm_openblas_mt.x \
      test_cgemm_openblas_mt.x \
      test_zgemm_openblas_mt.x

openblas-syrk-st: \
      test_ssyrk_openblas_st.x \
      test_dsyrk_openblas_st.x \
      test_csyrk_openblas_st.x \
      test_zsyrk_openblas_st.x

openblas-syrk-mt: \
      test_ssyrk_openblas_mt.x \
      test_dsyrk_openblas_mt.x \
      test_csyrk_openblas_mt.x \
      test_zsyrk_openblas_mt.x

openblas-hemm-st: \
      test_shemm_openblas_st.x \
      test_dhemm_openblas_st.x \
      test_chemm_openblas_st.x \
      test_zhemm_openblas_st.x

openblas-hemm-mt: \
      test_shemm_openblas_mt.x \
      test_dhemm_openblas_mt.x \
      test_chemm_openblas_mt.x \
      test_zhemm_openblas_mt.x

openblas-trmm-st: \
      test_strmm_openblas_st.x \
      test_dtrmm_openblas_st.x \
      test_ctrmm_openblas_st.x \
      test_ztrmm_openblas_st.x

openblas-trmm-mt: \
      test_strmm_openblas_mt.x \
      test_dtrmm_openblas_mt.x \
      test_ctrmm_openblas_mt.x \
      test_ztrmm_openblas_mt.x

mkl-gemm-st: \
      test_sgemm_mkl_st.x \
      test_dgemm_mkl_st.x \
      test_cgemm_mkl_st.x \
      test_zgemm_mkl_st.x

mkl-gemm-mt: \
      test_sgemm_mkl_mt.x \
      test_dgemm_mkl_mt.x \
      test_cgemm_mkl_mt.x \
      test_zgemm_mkl_mt.x

mkl-syrk-st: \
      test_ssyrk_mkl_st.x \
      test_dsyrk_mkl_st.x \
      test_csyrk_mkl_st.x \
      test_zsyrk_mkl_st.x

mkl-syrk-mt: \
      test_ssyrk_mkl_mt.x \
      test_dsyrk_mkl_mt.x \
      test_csyrk_mkl_mt.x \
      test_zsyrk_mkl_mt.x


mkl-hemm-st: \
      test_shemm_mkl_st.x \
      test_dhemm_mkl_st.x \
      test_chemm_mkl_st.x \
      test_zhemm_mkl_st.x

mkl-hemm-mt: \
      test_shemm_mkl_mt.x \
      test_dhemm_mkl_mt.x \
      test_chemm_mkl_mt.x \
      test_zhemm_mkl_mt.x

mkl-trmm-st: \
      test_strmm_mkl_st.x \
      test_dtrmm_mkl_st.x \
      test_ctrmm_mkl_st.x \
      test_ztrmm_mkl_st.x

mkl-trmm-mt: \
      test_strmm_mkl_mt.x \
      test_dtrmm_mkl_mt.x \
      test_ctrmm_mkl_mt.x \
      test_ztrmm_mkl_mt.x

armpl-gemm-st: \
      test_sgemm_armpl_st.x \
      test_dgemm_armpl_st.x \
      test_cgemm_armpl_st.x \
      test_zgemm_armpl_st.x

armpl-gemm-mt: \
      test_sgemm_armpl_mt.x \
      test_dgemm_armpl_mt.x \
      test_cgemm_armpl_mt.x \
      test_zgemm_armpl_mt.x

armpl-syrk-st: \
      test_ssyrk_armpl_st.x \
      test_dsyrk_armpl_st.x \
      test_csyrk_armpl_st.x \
      test_zsyrk_armpl_st.x

armpl-syrk-mt: \
      test_ssyrk_armpl_mt.x \
      test_dsyrk_armpl_mt.x \
      test_csyrk_armpl_mt.x \
      test_zsyrk_armpl_mt.x

armpl-hemm-st: \
      test_shemm_armpl_st.x \
      test_dhemm_armpl_st.x \
      test_chemm_armpl_st.x \

=== test/studies/thunderx2/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis-gemm-st openblas-gemm-st mkl-gemm-st acml-gemm-st \
        blis-gemm-mt openblas-gemm-mt mkl-gemm-mt acml-gemm-mt \
        blis-syrk-st openblas-syrk-st mkl-syrk-st armpl-syrk-st \
        blis-syrk-mt openblas-syrk-mt mkl-syrk-mt armpl-syrk-mt \
        blis-hemm-st openblas-hemm-st mkl-hemm-st armpl-hemm-st \
        blis-hemm-mt openblas-hemm-mt mkl-hemm-mt armpl-hemm-mt \
        blis-trmm-st openblas-trmm-st mkl-trmm-st armpl-trmm-st \
        blis-trmm-mt openblas-trmm-mt mkl-trmm-mt armpl-trmm-mt \
        clean cleanx

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../../..
LIB_PATH    = ../../../lib/$(CONFIG_NAME)
INC_PATH    = ../../../include/$(CONFIG_NAME)
SHARE_PATH := ../../..
endif


#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk

#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/OpenBLAS/lib

MKL_LIB_PATH   := ${MKLROOT}/lib/intel64

ARMPL_LIB_PATH := /opt/arm/armpl-18.4.0_ThunderX2CN99_Ubuntu-16.04_gcc_7.1.0_aarch64-linux/lib/

ACML_LIB_PATH  := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_int64/lib
ACMLP_LIB_PATH := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_mp_int64/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblas.a

# ATLAS
ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
                  $(HOME_LIB_PATH)/libatlas.a

# For ARMPL
ARMPL_LIB        := $(ARMPL_LIB_PATH)/libarmpl_lp64.a
ARMPLP_LIB       := $(ARMPL_LIB_PATH)/libarmpl_lp64_mp.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

# ACML
ACML_LIB       := -L$(ACML_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml
ACMLP_LIB      := -L$(ACMLP_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml_mp



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-frame-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -g -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
#LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Datatype
DT_S     := -DDT=BLIS_FLOAT
DT_D     := -DDT=BLIS_DOUBLE
DT_C     := -DDT=BLIS_SCOMPLEX
DT_Z     := -DDT=BLIS_DCOMPLEX

# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Complex implementation type
D3MHW    := -DIND=BLIS_3MH
D3M1     := -DIND=BLIS_3M1
D4MHW    := -DIND=BLIS_4MH
D4M1B    := -DIND=BLIS_4M1B
D4M1A    := -DIND=BLIS_4M1A
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
STR_3MHW := -DSTR=\"3mhw\"
STR_3M1  := -DSTR=\"3m1\"
STR_4MHW := -DSTR=\"4mhw\"
STR_4M1B := -DSTR=\"4m1b\"
STR_4M1A := -DSTR=\"4m1a\"
STR_1M   := -DSTR=\"1m\"
STR_NAT  := -DSTR=\"asm\"
STR_OBL  := -DSTR=\"openblas\"
STR_MKL  := -DSTR=\"mkl\"
STR_ACML := -DSTR=\"acml\"
STR_ARMPL:= -DSTR=\"armpl\"


# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=40 \
            -DP_END=2000 \
            -DP_INC=40

PDEF_MT  := -DP_BEGIN=200 \
            -DP_END=10000 \
            -DP_INC=200



#
# --- Targets/rules ------------------------------------------------------------
#

all-st:      blis-st openblas-st armpl-st
all-mt:      blis-mt openblas-mt armpl-mt

blis-st:     blis-gemm-st blis-syrk-st blis-hemm-st blis-trmm-st
blis-mt:     blis-gemm-mt blis-syrk-mt blis-hemm-mt blis-trmm-mt

openblas-st: openblas-gemm-st openblas-syrk-st openblas-hemm-st openblas-trmm-st
openblas-mt: openblas-gemm-mt openblas-syrk-mt openblas-hemm-mt openblas-trmm-mt

mkl-st:      mkl-gemm-st mkl-syrk-st mkl-hemm-st mkl-trmm-st
mkl-mt:      mkl-gemm-mt mkl-syrk-mt mkl-hemm-mt mkl-trmm-mt

armpl-st:      armpl-gemm-st armpl-syrk-st armpl-hemm-st armpl-trmm-st
armpl-mt:      armpl-gemm-mt armpl-syrk-mt armpl-hemm-mt armpl-trmm-mt

blis-gemm-st: \
      test_sgemm_asm_blis_st.x \
      test_dgemm_asm_blis_st.x \
      \
      test_cgemm_1m_blis_st.x \
      test_zgemm_1m_blis_st.x \
      test_cgemm_asm_blis_st.x \
      test_zgemm_asm_blis_st.x

blis-syrk-st: \
      test_ssyrk_asm_blis_st.x \
      test_dsyrk_asm_blis_st.x \
      test_csyrk_1m_blis_st.x \
      test_zsyrk_1m_blis_st.x

blis-syrk-mt: \
      test_ssyrk_asm_blis_mt.x \
      test_dsyrk_asm_blis_mt.x \
      test_csyrk_1m_blis_mt.x \
      test_zsyrk_1m_blis_mt.x

blis-hemm-st: \
      test_shemm_asm_blis_st.x \
      test_dhemm_asm_blis_st.x \
      test_chemm_1m_blis_st.x \
      test_zhemm_1m_blis_st.x

blis-hemm-mt: \
      test_shemm_asm_blis_mt.x \
      test_dhemm_asm_blis_mt.x \
      test_chemm_1m_blis_mt.x \
      test_zhemm_1m_blis_mt.x

blis-trmm-st: \
      test_strmm_asm_blis_st.x \
      test_dtrmm_asm_blis_st.x \
      test_ctrmm_1m_blis_st.x \
      test_ztrmm_1m_blis_st.x

blis-trmm-mt: \
      test_strmm_asm_blis_mt.x \
      test_dtrmm_asm_blis_mt.x \
      test_ctrmm_1m_blis_mt.x \
      test_ztrmm_1m_blis_mt.x 


blis-gemm-mt: \
      test_sgemm_asm_blis_mt.x \
      test_dgemm_asm_blis_mt.x \
      \
      test_cgemm_1m_blis_mt.x \
      test_zgemm_1m_blis_mt.x \
      test_cgemm_asm_blis_mt.x \
      test_zgemm_asm_blis_mt.x

openblas-gemm-st: \
      test_sgemm_openblas_st.x \
      test_dgemm_openblas_st.x \
      test_cgemm_openblas_st.x \
      test_zgemm_openblas_st.x

openblas-gemm-mt: \
      test_sgemm_openblas_mt.x \
      test_dgemm_openblas_mt.x \
      test_cgemm_openblas_mt.x \
      test_zgemm_openblas_mt.x

openblas-syrk-st: \
      test_ssyrk_openblas_st.x \
      test_dsyrk_openblas_st.x \
      test_csyrk_openblas_st.x \
      test_zsyrk_openblas_st.x

openblas-syrk-mt: \
      test_ssyrk_openblas_mt.x \
      test_dsyrk_openblas_mt.x \
      test_csyrk_openblas_mt.x \
      test_zsyrk_openblas_mt.x

openblas-hemm-st: \
      test_shemm_openblas_st.x \
      test_dhemm_openblas_st.x \
      test_chemm_openblas_st.x \
      test_zhemm_openblas_st.x

openblas-hemm-mt: \
      test_shemm_openblas_mt.x \
      test_dhemm_openblas_mt.x \
      test_chemm_openblas_mt.x \
      test_zhemm_openblas_mt.x

openblas-trmm-st: \
      test_strmm_openblas_st.x \
      test_dtrmm_openblas_st.x \
      test_ctrmm_openblas_st.x \
      test_ztrmm_openblas_st.x

openblas-trmm-mt: \
      test_strmm_openblas_mt.x \
      test_dtrmm_openblas_mt.x \
      test_ctrmm_openblas_mt.x \
      test_ztrmm_openblas_mt.x

mkl-gemm-st: \
      test_sgemm_mkl_st.x \
      test_dgemm_mkl_st.x \
      test_cgemm_mkl_st.x \
      test_zgemm_mkl_st.x

mkl-gemm-mt: \
      test_sgemm_mkl_mt.x \
      test_dgemm_mkl_mt.x \
      test_cgemm_mkl_mt.x \
      test_zgemm_mkl_mt.x

mkl-syrk-st: \
      test_ssyrk_mkl_st.x \
      test_dsyrk_mkl_st.x \
      test_csyrk_mkl_st.x \
      test_zsyrk_mkl_st.x

mkl-syrk-mt: \
      test_ssyrk_mkl_mt.x \
      test_dsyrk_mkl_mt.x \
      test_csyrk_mkl_mt.x \
      test_zsyrk_mkl_mt.x


mkl-hemm-st: \
      test_shemm_mkl_st.x \
      test_dhemm_mkl_st.x \
      test_chemm_mkl_st.x \
      test_zhemm_mkl_st.x

mkl-hemm-mt: \
      test_shemm_mkl_mt.x \
      test_dhemm_mkl_mt.x \
      test_chemm_mkl_mt.x \
      test_zhemm_mkl_mt.x

mkl-trmm-st: \
      test_strmm_mkl_st.x \
      test_dtrmm_mkl_st.x \
      test_ctrmm_mkl_st.x \
      test_ztrmm_mkl_st.x

mkl-trmm-mt: \
      test_strmm_mkl_mt.x \
      test_dtrmm_mkl_mt.x \
      test_ctrmm_mkl_mt.x \
      test_ztrmm_mkl_mt.x

armpl-gemm-st: \
      test_sgemm_armpl_st.x \
      test_dgemm_armpl_st.x \
      test_cgemm_armpl_st.x \
      test_zgemm_armpl_st.x

armpl-gemm-mt: \
      test_sgemm_armpl_mt.x \
      test_dgemm_armpl_mt.x \
      test_cgemm_armpl_mt.x \
      test_zgemm_armpl_mt.x

armpl-syrk-st: \
      test_ssyrk_armpl_st.x \
      test_dsyrk_armpl_st.x \
      test_csyrk_armpl_st.x \
      test_zsyrk_armpl_st.x

armpl-syrk-mt: \
      test_ssyrk_armpl_mt.x \
      test_dsyrk_armpl_mt.x \
      test_csyrk_armpl_mt.x \
      test_zsyrk_armpl_mt.x

armpl-hemm-st: \
      test_shemm_armpl_st.x \
      test_dhemm_armpl_st.x \
      test_chemm_armpl_st.x \
      test_zhemm_armpl_st.x

armpl-hemm-mt: \
      test_shemm_armpl_mt.x \
      test_dhemm_armpl_mt.x \
      test_chemm_armpl_mt.x \
      test_zhemm_armpl_mt.x

armpl-trmm-st: \
      test_strmm_armpl_st.x \
      test_dtrmm_armpl_st.x \
      test_ctrmm_armpl_st.x \
      test_ztrmm_armpl_st.x

armpl-trmm-mt: \
      test_strmm_armpl_mt.x \
      test_dtrmm_armpl_mt.x \
      test_ctrmm_armpl_mt.x \

=== test/sup/old/supst/Makefile ===
#!/bin/bash
#
#  BLIS
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2019, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all all-st all-mt \
        blis blis-st blis-mt \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64

# netlib BLAS
NETLIB_LIB     := $(HOME_LIB_PATH)/libblas.a

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# BLASFEO
BLASFEO_LIB    := $(HOME_LIB_PATH)/libblasfeo.a

# libxsmm
LIBXSMM_LIB    := $(HOME_LIB_PATH)/libxsmm.a -ldl \
                  $(NETLIB_LIB) -lgfortran

# ATLAS
ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
                  $(HOME_LIB_PATH)/libatlas.a

# Eigen
EIGEN_INC      := $(HOME)/flame/eigen/include/eigen3
EIGEN_LIB      := $(HOME_LIB_PATH)/libeigen_blas_static.a
EIGENP_LIB     := $(EIGEN_LIB)

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

VENDOR_LIB     := $(MKL_LIB)
VENDORP_LIB    := $(MKLP_LIB)


#
# --- Problem size definitions -------------------------------------------------
#

# Single core
PS_BEGIN_3L := 2
PS_MAX_3L   := 400
PS_INC_3L   := 2

PS_BEGIN_2L := 4
PS_MAX_2L   := 800
PS_INC_2L   := 4

PS_BEGIN_1L := 32
PS_MAX_1L   := 6400
PS_INC_1L   := 32


#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-frame-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Define a set of CFLAGS for use with C++ and Eigen.
CXXFLAGS       := $(subst -std=c99,-std=c++11,$(CFLAGS))
CXXFLAGS       += -I$(EIGEN_INC)

# Create a copy of CXXFLAGS without -fopenmp in order to disable multithreading.
CXXFLAGS_ST    := -march=native $(subst -fopenmp,,$(CXXFLAGS))
CXXFLAGS_MT    := -march=native $(CXXFLAGS)

# Single or multithreaded string.
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Number of trials per problem size.
N_TRIALS := -DN_TRIALS=3

# Problem size specification.
PDEF_ST_1L := -DP_BEGIN=$(PS_BEGIN_1L) -DP_MAX=$(PS_MAX_1L) -DP_INC=$(PS_INC_1L)
PDEF_ST_2L := -DP_BEGIN=$(PS_BEGIN_2L) -DP_MAX=$(PS_MAX_2L) -DP_INC=$(PS_INC_2L)
PDEF_ST_3L := -DP_BEGIN=$(PS_BEGIN_3L) -DP_MAX=$(PS_MAX_3L) -DP_INC=$(PS_INC_3L)

ifeq ($(E),1)
ERRCHK := -DERROR_CHECK
else
ERRCHK := -DNO_ERROR_CHECK
endif

# Enumerate possible datatypes and computation precisions.
#dts := s d c z
DTS := d

TRANS := n_n \
         n_t \
         t_n \
         t_t

# While BLIS supports all combinations of row and column storage for matrices
# C, A, and B, the alternatives mostly only support CBLAS APIs, which inherently
# support only "all row-storage" or "all column-storage". Thus, we disable the
# building of those other drivers so that compilation/linking completes sooner.
#STORS := r_r_r \
#         r_r_c \
#         r_c_r \
#         r_c_c \
#         c_r_r \
#         c_r_c \
#         c_c_r \
#         c_c_c
STORS := r_r_r \
         c_c_c


SHAPES := l_l_s \
          l_s_l \
          s_l_l \
          s_s_l \
          s_l_s \
          l_s_s \
          l_l_l

SMS := 6
SNS := 8
SKS := 4


#
# --- Function definitions -----------------------------------------------------
#

# A function to strip the underscores from a list of strings.
stripu = $(subst _,,$(1))

# Various functions that help us construct the datatype combinations and then
# extract the needed datatype strings and C preprocessor define flags.
get-1of2 = $(word 1,$(subst _, ,$(1)))
get-2of2 = $(word 2,$(subst _, ,$(1)))

get-1of3 = $(word 1,$(subst _, ,$(1)))
get-2of3 = $(word 2,$(subst _, ,$(1)))
get-3of3 = $(word 3,$(subst _, ,$(1)))

# A function to return the correct PDEFS_ST variable given the shape string.
get-pdefs = $(strip $(subst l_l_l,$(PDEF_ST_3L), \
                    $(subst l_l_s,$(PDEF_ST_2L), \
                    $(subst l_s_l,$(PDEF_ST_2L), \
                    $(subst s_l_l,$(PDEF_ST_2L), \
                    $(subst s_s_l,$(PDEF_ST_1L), \
                    $(subst s_l_s,$(PDEF_ST_1L), \
                    $(subst l_s_s,$(PDEF_ST_1L),$(1)))))))))

# Datatype defs.
get-dt-cpp = $(strip \
             $(if $(findstring s,$(1)),-DDT=BLIS_FLOAT    -DIS_FLOAT,\
             $(if $(findstring d,$(1)),-DDT=BLIS_DOUBLE   -DIS_DOUBLE,\
             $(if $(findstring c,$(1)),-DDT=BLIS_SCOMPLEX -DIS_SCOMPLEX,\
                                       -DDT=BLIS_DCOMPLEX -DIS_DCOMPLEX))))

# Transpose defs.
get-tra-defs-a = $(strip $(subst n,-DTRANSA=BLIS_NO_TRANSPOSE -DA_NOTRANS, \
                         $(subst t,-DTRANSA=BLIS_TRANSPOSE    -DA_TRANS,$(call get-1of2,$(1)))))
get-tra-defs-b = $(strip $(subst n,-DTRANSB=BLIS_NO_TRANSPOSE -DB_NOTRANS, \
                         $(subst t,-DTRANSB=BLIS_TRANSPOSE    -DB_TRANS,$(call get-2of2,$(1)))))
get-tra-defs = $(call get-tra-defs-a,$(1)) $(call get-tra-defs-b,$(1))

# Storage defs.
get-sto-uch-a = $(strip $(subst r,R, \
                        $(subst c,C,$(call get-1of3,$(1)))))
get-sto-uch-b = $(strip $(subst r,R, \
                        $(subst c,C,$(call get-2of3,$(1)))))
get-sto-uch-c = $(strip $(subst r,R, \
                        $(subst c,C,$(call get-3of3,$(1)))))
get-sto-defs = $(strip \
                 -DSTOR3=BLIS_$(call get-sto-uch-a,$(1))$(call get-sto-uch-b,$(1))$(call get-sto-uch-c,$(1)) \
                 -DA_STOR_$(call get-sto-uch-a,$(1)) \
                 -DB_STOR_$(call get-sto-uch-b,$(1)) \
                 -DC_STOR_$(call get-sto-uch-c,$(1)))

# Dimension defs.
get-shape-defs-cm = $(if $(findstring l,$(1)),-DM_DIM=-1,-DM_DIM=$(2))
get-shape-defs-cn = $(if $(findstring l,$(1)),-DN_DIM=-1,-DN_DIM=$(2))
get-shape-defs-ck = $(if $(findstring l,$(1)),-DK_DIM=-1,-DK_DIM=$(2))
get-shape-defs-m  = $(call get-shape-defs-cm,$(call get-1of3,$(1)),$(2))
get-shape-defs-n  = $(call get-shape-defs-cn,$(call get-2of3,$(1)),$(2))
get-shape-defs-k  = $(call get-shape-defs-ck,$(call get-3of3,$(1)),$(2))

# arguments: 1: shape (w/ underscores)  2: smallm  3: smalln  4: smallk
get-shape-defs    = $(strip $(call get-shape-defs-m,$(1),$(2)) \
                            $(call get-shape-defs-n,$(1),$(3)) \
                            $(call get-shape-defs-k,$(1),$(4)))

#$(error l_l_s 6 8 4 = $(call get-shape-defs,l_l_s,6,8,4))

# Shape-dimension string.
get-shape-str-ch  = $(if $(findstring l,$(1)),p,$(2))
get-shape-str-m   = $(call get-shape-str-ch,$(call get-1of3,$(1)),$(2))
get-shape-str-n   = $(call get-shape-str-ch,$(call get-2of3,$(1)),$(2))
get-shape-str-k   = $(call get-shape-str-ch,$(call get-3of3,$(1)),$(2))

# arguments: 1: shape (w/ underscores)  2: smallm  3: smalln  4: smallk
get-shape-dim-str = m$(call get-shape-str-m,$(1),$(2))n$(call get-shape-str-n,$(1),$(3))k$(call get-shape-str-k,$(1),$(4))

# Implementation defs.
# Define a function to return the appropriate -DSTR= and -D[BLIS|BLAS] flags.
get-imp-defs = $(strip $(subst  blissup,-DSTR=\"$(1)\" -DBLIS -DSUP, \
                       $(subst blislpab,-DSTR=\"$(1)\" -DBLIS, \
                       $(subst    eigen,-DSTR=\"$(1)\" -DEIGEN, \
                       $(subst openblas,-DSTR=\"$(1)\" -DCBLAS, \
                       $(subst  blasfeo,-DSTR=\"$(1)\" -DCBLAS, \
                       $(subst  libxsmm,-DSTR=\"$(1)\" -DBLAS -DXSMM, \
                       $(subst   vendor,-DSTR=\"$(1)\" -DCBLAS,$(1)))))))))

TRANS0  = $(call stripu,$(TRANS))
STORS0  = $(call stripu,$(STORS))

# Limit BLAS and Eigen to only using all row-stored, or all column-stored matrices.
# Also, limit libxsmm to using all column-stored matrices since it does not offer
# CBLAS interfaces.
BSTORS0 = rrr ccc
ESTORS0 = rrr ccc
XSTORS0 = ccc


#
# --- Object and binary file definitons ----------------------------------------
#

get-st-objs = $(foreach dt,$(1),$(foreach tr,$(2),$(foreach st,$(3),$(foreach sh,$(4),$(foreach sm,$(5),$(foreach sn,$(6),$(foreach sk,$(7),test_$(dt)gemm_$(tr)_$(st)_$(call get-shape-dim-str,$(sh),$(sm),$(sn),$(sk))_$(8)_st.o)))))))

# Build a list of object files and binaries for each single-threaded

=== debian/changelog ===
blis (1.1-3) unstable; urgency=medium

  * Team upload.
  [ Nick Rosbrook ]
  * d/rules: exclude build flags to enable frame pointers.
  [ Adrian Bunk ]
  * Backport upstream fixes for FTBFS with GCC 15. Closes: #1096377.
  [ Santiago Vila ]
  * Add debian/salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Sep 2025 21:35:00 +0200

blis (1.1-2) unstable; urgency=medium

  * Add patch to alias *gemmt_ as *gemmtr_.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Jan 2025 18:37:36 -0500

blis (1.1-1) unstable; urgency=medium

  * New upstream version 1.1

 -- Mo Zhou <lumin@debian.org>  Mon, 20 Jan 2025 10:56:48 -0500

=== debian/control ===
Source: blis
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>,
           Mo Zhou <lumin@debian.org>,
Section: math
Priority: optional
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/blis
Vcs-Git: https://salsa.debian.org/science-team/blis.git
Homepage: https://github.com/flame/blis
Build-Depends: debhelper-compat (= 13), python3,
Rules-Requires-Root: no

Package: libblis-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis4 (= ${binary:Version}), ${misc:Depends},
 libblis-openmp-dev | libblis-pthread-dev | libblis-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 32-bit BlasInt variants.

Package: libblis-openmp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis4-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t openmp) version of development files.

Package: libblis-pthread-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis4-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t pthread) version of development files.

Package: libblis-serial-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis4-serial (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework (dev,32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains (-t no) version development files.

Package: libblis4
Architecture: any
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends}, ${shlibs:Depends},
  libblis4-openmp (= ${binary:Version})
  | libblis4-pthread (= ${binary:Version})
  | libblis4-serial (= ${binary:Version}),
Description: BLAS-like Library Instantiation Software Framework (32bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls one of the 32-bit-BlasInt shared library variants.

Package: libblis4-openmp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.4, libblas.so.3,
Breaks: libblis2-openmp, libblis3-openmp,
Replaces: libblis2-openmp, libblis3-openmp,
Description: BLAS-like Library Instantiation Software Framework (32bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t openmp) version of shared library.

Package: libblis4-pthread
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.4, libblas.so.3,
Breaks: libblis2-pthread, libblis3-pthread,
Replaces: libblis2-pthread, libblis3-pthread,
Description: BLAS-like Library Instantiation Software Framework (32bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t pthread) version of shared library.

Package: libblis4-serial
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.4, libblas.so.3,
Breaks: libblis2-serial, libblis3-serial,
Replaces: libblis2-serial, libblis3-serial,
Description: BLAS-like Library Instantiation Software Framework (32bit,serial)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-t no) version of shared library.

Package: libblis64-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-4 (= ${binary:Version}), ${misc:Depends},
 libblis64-openmp-dev | libblis64-pthread-dev | libblis64-serial-dev,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,meta)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files for one of the 64-bit BlasInt variants.

Package: libblis64-openmp-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-4-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,openmp)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the (-b 64 -i 64 -t openmp) version of development files.

Package: libblis64-pthread-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-4-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework (dev,64bit,pthread)
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYTHON=/usr/bin/python3  # for the upstream build system

# Select target architecture
# armhf: upstream's armv7a kernel assumes NEON. Using generic kernels currently.
CONFIG_amd64      = x86_64
CONFIG_arm64      = cortexa57
CONFIG_ppc64el    = generic
CONFIG_kfreebsd-amd64 = x86_64
CONFIG            = $(word 1, $(CONFIG_$(DEB_HOST_ARCH)) generic)

# Update-Alternatives Priority Settings
UAPRI_O = 80
UAPRI_P = 75
UAPRI_S = 70

# SOVERSION (Following upstream)
SOVER := 4

# Threading + Indexing Flavours
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64))
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial 64-$(SOVER)-openmp 64-$(SOVER)-pthread 64-$(SOVER)-serial
else
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial
endif

# Common flags for every variant
FLAGS := \
	--enable-verbose-make \
	--prefix=/usr \
	--enable-cblas \
	--enable-static \
	--enable-shared \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

# FLAG Tweaks
export CFLAGS = $(filter-out -O2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer, $(shell dpkg-buildflags --get CFLAGS)) \
               $(shell dpkg-buildflags --get CPPFLAGS)

##
SRCS := $(filter-out debian $(FLAVORS), $(wildcard ./*))

##


%:
	dh $@ -Smakefile

clean_%:
	-$(RM) -rf $*

override_dh_auto_clean: $(addprefix clean_, $(FLAVORS))
	dh_auto_clean

create_symlinks:
	# BLIS/BLAS
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis$(SOVER)-XXX.symbols.generic libblis$(SOVER)-$$j.symbols ;\
		for i in kfreebsd-amd64 amd64 arm64; do  \
			ln -sr libblis$(SOVER)-XXX.symbols.$$i libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
		for i in i386 x32; do \
			ln -sr libblis$(SOVER)-XXX.symbols.i386 libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;
	# BLIS64/BLAS64
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis64-$(SOVER)-XXX.symbols.generic libblis64-$(SOVER)-$$j.symbols ;\
		for i in kfreebsd-amd64 amd64 arm64; do \
			ln -sr libblis64-$(SOVER)-XXX.symbols.$$i libblis64-$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;

config_%:
	# Generate maintainer scripts from templates
	set -e; cd debian; if test -z "$$(echo $* | grep 64)"; then \
		cp libblis$(SOVER)-XXX.postinst     libblis$*.postinst; \
		cp libblis$(SOVER)-XXX.prerm        libblis$*.prerm; \
		cp libblis-XXX-dev.postinst  libblis$(subst $(SOVER),,$*)-dev.postinst; \
		cp libblis-XXX-dev.prerm     libblis$(subst $(SOVER),,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst $(SOVER),,$*)-dev.postinst \
			libblis$(subst $(SOVER),,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst $(SOVER),,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_O)/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_P)/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_S)/g" $$SCRIPT; \
			fi; \
		done; \
	else \
		cp libblis64-$(SOVER)-XXX.postinst     libblis$*.postinst; \
		cp libblis64-$(SOVER)-XXX.prerm        libblis$*.prerm; \
		cp libblis64-XXX-dev.postinst   libblis$(subst -$(SOVER)-,-,$*)-dev.postinst; \
		cp libblis64-XXX-dev.prerm      libblis$(subst -$(SOVER)-,-,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst -$(SOVER)-,-,$*)-dev.postinst \
			libblis$(subst -$(SOVER)-,-,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst -$(SOVER)-,-,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_O)/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_P)/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/$(UAPRI_S)/g" $$SCRIPT; \
			fi; \
		done; \
	fi;
	# Run upstream configure script in duplicated source root directories
	mkdir $*
	cp -r $(SRCS) $*/
	set -e; cd $*; if test -z "$$(echo $* | grep 64)"; then \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -t $(subst $(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	else \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -b 64 -i 64 -t $(subst 64-$(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) -b 64 -i 64 --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis64.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	fi;

override_dh_auto_configure: $(addprefix config_, $(FLAVORS)) create_symlinks
	:

build_%:
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas64.so.3 LIBBLIS=libblis64 ; \
	else \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas.so.3; \
	fi;

override_dh_auto_build: $(addprefix build_, $(FLAVORS))
	:

test_%:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		$(MAKE) -C$* check LIBBLIS=libblis64; \
	else \
		$(MAKE) -C$* check; \
	fi;
else
	true  # Or Make won't be able to find the test_% target.
endif

ifeq (,$(filter hurd-i386,$(DEB_HOST_ARCH)))
override_dh_auto_test: $(addprefix test_, $(FLAVORS))
	:
else
override_dh_auto_test:
	:
endif

install_%:
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*
	# In case we forgot to compile something
	-set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_install -B$* -- LIBBLIS=libblis64; \
	else \
		dh_auto_install -B$*; \
	fi;
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*

	# Install things manually
	set -e; if test -z "$$(echo $* | grep 64)"; then \
		install -Dm0644 $*/lib/*/libblis.so        debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so.$(SOVER) ;\
		install -Dm0644 $*/lib/*/libblas.so.3      debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so.3 ;\
		ln -s libblas.so.3                         debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so ;\
		install -Dm0644 $*/lib/*/libblis.a         debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.a ;\
		ln -s libblis.so.$(SOVER)                  debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so ;\
		install -Dm0644 $*/include/*/blis.h        debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/blis.h ;\
		install -Dm0644 $*/include/*/cblas.h       debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/cblas.h ;\
		mkdir -p                                   debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/config/$(CONFIG)/;\
		cp -v $*/common.mk                         debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/;\
		cp -v $*/config.mk                         debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/;\
		cp -v config/$(CONFIG)/make_defs.mk        debian/libblis$(subst $(SOVER),,$*)-dev/usr/share/blis$(subst $(SOVER),,$*)-$(DEB_HOST_MULTIARCH)/config/$(CONFIG)/;\
        mkdir -p                                   debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig ;\
        install -Dm0644 $*/blis.pc debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/blis$(subst $(SOVER),,$*)/blis.pc ;\
	else \

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/blis-$1\.tar\.gz/ \
  https://github.com/flame/blis/tags .*/v?(\d\S+)\.tar\.gz
